// Code generated by entc, DO NOT EDIT.

package instanceruntime

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/google/uuid"
	"github.com/vorteil/direktiv/pkg/flow/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Input applies equality check predicate on the "input" field. It's identical to InputEQ.
func Input(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInput), v))
	})
}

// Data applies equality check predicate on the "data" field. It's identical to DataEQ.
func Data(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldData), v))
	})
}

// Controller applies equality check predicate on the "controller" field. It's identical to ControllerEQ.
func Controller(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldController), v))
	})
}

// Memory applies equality check predicate on the "memory" field. It's identical to MemoryEQ.
func Memory(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldMemory), v))
	})
}

// Output applies equality check predicate on the "output" field. It's identical to OutputEQ.
func Output(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldOutput), v))
	})
}

// StateBeginTime applies equality check predicate on the "stateBeginTime" field. It's identical to StateBeginTimeEQ.
func StateBeginTime(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStateBeginTime), v))
	})
}

// Deadline applies equality check predicate on the "deadline" field. It's identical to DeadlineEQ.
func Deadline(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDeadline), v))
	})
}

// Attempts applies equality check predicate on the "attempts" field. It's identical to AttemptsEQ.
func Attempts(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldAttempts), v))
	})
}

// CallerData applies equality check predicate on the "caller_data" field. It's identical to CallerDataEQ.
func CallerData(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCallerData), v))
	})
}

// InstanceContext applies equality check predicate on the "instanceContext" field. It's identical to InstanceContextEQ.
func InstanceContext(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInstanceContext), v))
	})
}

// StateContext applies equality check predicate on the "stateContext" field. It's identical to StateContextEQ.
func StateContext(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStateContext), v))
	})
}

// InputEQ applies the EQ predicate on the "input" field.
func InputEQ(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInput), v))
	})
}

// InputNEQ applies the NEQ predicate on the "input" field.
func InputNEQ(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldInput), v))
	})
}

// InputIn applies the In predicate on the "input" field.
func InputIn(vs ...[]byte) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldInput), v...))
	})
}

// InputNotIn applies the NotIn predicate on the "input" field.
func InputNotIn(vs ...[]byte) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldInput), v...))
	})
}

// InputGT applies the GT predicate on the "input" field.
func InputGT(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldInput), v))
	})
}

// InputGTE applies the GTE predicate on the "input" field.
func InputGTE(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldInput), v))
	})
}

// InputLT applies the LT predicate on the "input" field.
func InputLT(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldInput), v))
	})
}

// InputLTE applies the LTE predicate on the "input" field.
func InputLTE(v []byte) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldInput), v))
	})
}

// DataEQ applies the EQ predicate on the "data" field.
func DataEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldData), v))
	})
}

// DataNEQ applies the NEQ predicate on the "data" field.
func DataNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldData), v))
	})
}

// DataIn applies the In predicate on the "data" field.
func DataIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldData), v...))
	})
}

// DataNotIn applies the NotIn predicate on the "data" field.
func DataNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldData), v...))
	})
}

// DataGT applies the GT predicate on the "data" field.
func DataGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldData), v))
	})
}

// DataGTE applies the GTE predicate on the "data" field.
func DataGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldData), v))
	})
}

// DataLT applies the LT predicate on the "data" field.
func DataLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldData), v))
	})
}

// DataLTE applies the LTE predicate on the "data" field.
func DataLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldData), v))
	})
}

// DataContains applies the Contains predicate on the "data" field.
func DataContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldData), v))
	})
}

// DataHasPrefix applies the HasPrefix predicate on the "data" field.
func DataHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldData), v))
	})
}

// DataHasSuffix applies the HasSuffix predicate on the "data" field.
func DataHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldData), v))
	})
}

// DataEqualFold applies the EqualFold predicate on the "data" field.
func DataEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldData), v))
	})
}

// DataContainsFold applies the ContainsFold predicate on the "data" field.
func DataContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldData), v))
	})
}

// ControllerEQ applies the EQ predicate on the "controller" field.
func ControllerEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldController), v))
	})
}

// ControllerNEQ applies the NEQ predicate on the "controller" field.
func ControllerNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldController), v))
	})
}

// ControllerIn applies the In predicate on the "controller" field.
func ControllerIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldController), v...))
	})
}

// ControllerNotIn applies the NotIn predicate on the "controller" field.
func ControllerNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldController), v...))
	})
}

// ControllerGT applies the GT predicate on the "controller" field.
func ControllerGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldController), v))
	})
}

// ControllerGTE applies the GTE predicate on the "controller" field.
func ControllerGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldController), v))
	})
}

// ControllerLT applies the LT predicate on the "controller" field.
func ControllerLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldController), v))
	})
}

// ControllerLTE applies the LTE predicate on the "controller" field.
func ControllerLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldController), v))
	})
}

// ControllerContains applies the Contains predicate on the "controller" field.
func ControllerContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldController), v))
	})
}

// ControllerHasPrefix applies the HasPrefix predicate on the "controller" field.
func ControllerHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldController), v))
	})
}

// ControllerHasSuffix applies the HasSuffix predicate on the "controller" field.
func ControllerHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldController), v))
	})
}

// ControllerIsNil applies the IsNil predicate on the "controller" field.
func ControllerIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldController)))
	})
}

// ControllerNotNil applies the NotNil predicate on the "controller" field.
func ControllerNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldController)))
	})
}

// ControllerEqualFold applies the EqualFold predicate on the "controller" field.
func ControllerEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldController), v))
	})
}

// ControllerContainsFold applies the ContainsFold predicate on the "controller" field.
func ControllerContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldController), v))
	})
}

// MemoryEQ applies the EQ predicate on the "memory" field.
func MemoryEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldMemory), v))
	})
}

// MemoryNEQ applies the NEQ predicate on the "memory" field.
func MemoryNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldMemory), v))
	})
}

// MemoryIn applies the In predicate on the "memory" field.
func MemoryIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldMemory), v...))
	})
}

// MemoryNotIn applies the NotIn predicate on the "memory" field.
func MemoryNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldMemory), v...))
	})
}

// MemoryGT applies the GT predicate on the "memory" field.
func MemoryGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldMemory), v))
	})
}

// MemoryGTE applies the GTE predicate on the "memory" field.
func MemoryGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldMemory), v))
	})
}

// MemoryLT applies the LT predicate on the "memory" field.
func MemoryLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldMemory), v))
	})
}

// MemoryLTE applies the LTE predicate on the "memory" field.
func MemoryLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldMemory), v))
	})
}

// MemoryContains applies the Contains predicate on the "memory" field.
func MemoryContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldMemory), v))
	})
}

// MemoryHasPrefix applies the HasPrefix predicate on the "memory" field.
func MemoryHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldMemory), v))
	})
}

// MemoryHasSuffix applies the HasSuffix predicate on the "memory" field.
func MemoryHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldMemory), v))
	})
}

// MemoryIsNil applies the IsNil predicate on the "memory" field.
func MemoryIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldMemory)))
	})
}

// MemoryNotNil applies the NotNil predicate on the "memory" field.
func MemoryNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldMemory)))
	})
}

// MemoryEqualFold applies the EqualFold predicate on the "memory" field.
func MemoryEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldMemory), v))
	})
}

// MemoryContainsFold applies the ContainsFold predicate on the "memory" field.
func MemoryContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldMemory), v))
	})
}

// FlowIsNil applies the IsNil predicate on the "flow" field.
func FlowIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldFlow)))
	})
}

// FlowNotNil applies the NotNil predicate on the "flow" field.
func FlowNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldFlow)))
	})
}

// OutputEQ applies the EQ predicate on the "output" field.
func OutputEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldOutput), v))
	})
}

// OutputNEQ applies the NEQ predicate on the "output" field.
func OutputNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldOutput), v))
	})
}

// OutputIn applies the In predicate on the "output" field.
func OutputIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldOutput), v...))
	})
}

// OutputNotIn applies the NotIn predicate on the "output" field.
func OutputNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldOutput), v...))
	})
}

// OutputGT applies the GT predicate on the "output" field.
func OutputGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldOutput), v))
	})
}

// OutputGTE applies the GTE predicate on the "output" field.
func OutputGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldOutput), v))
	})
}

// OutputLT applies the LT predicate on the "output" field.
func OutputLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldOutput), v))
	})
}

// OutputLTE applies the LTE predicate on the "output" field.
func OutputLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldOutput), v))
	})
}

// OutputContains applies the Contains predicate on the "output" field.
func OutputContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldOutput), v))
	})
}

// OutputHasPrefix applies the HasPrefix predicate on the "output" field.
func OutputHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldOutput), v))
	})
}

// OutputHasSuffix applies the HasSuffix predicate on the "output" field.
func OutputHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldOutput), v))
	})
}

// OutputIsNil applies the IsNil predicate on the "output" field.
func OutputIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldOutput)))
	})
}

// OutputNotNil applies the NotNil predicate on the "output" field.
func OutputNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldOutput)))
	})
}

// OutputEqualFold applies the EqualFold predicate on the "output" field.
func OutputEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldOutput), v))
	})
}

// OutputContainsFold applies the ContainsFold predicate on the "output" field.
func OutputContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldOutput), v))
	})
}

// StateBeginTimeEQ applies the EQ predicate on the "stateBeginTime" field.
func StateBeginTimeEQ(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeNEQ applies the NEQ predicate on the "stateBeginTime" field.
func StateBeginTimeNEQ(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeIn applies the In predicate on the "stateBeginTime" field.
func StateBeginTimeIn(vs ...time.Time) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldStateBeginTime), v...))
	})
}

// StateBeginTimeNotIn applies the NotIn predicate on the "stateBeginTime" field.
func StateBeginTimeNotIn(vs ...time.Time) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldStateBeginTime), v...))
	})
}

// StateBeginTimeGT applies the GT predicate on the "stateBeginTime" field.
func StateBeginTimeGT(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeGTE applies the GTE predicate on the "stateBeginTime" field.
func StateBeginTimeGTE(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeLT applies the LT predicate on the "stateBeginTime" field.
func StateBeginTimeLT(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeLTE applies the LTE predicate on the "stateBeginTime" field.
func StateBeginTimeLTE(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldStateBeginTime), v))
	})
}

// StateBeginTimeIsNil applies the IsNil predicate on the "stateBeginTime" field.
func StateBeginTimeIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldStateBeginTime)))
	})
}

// StateBeginTimeNotNil applies the NotNil predicate on the "stateBeginTime" field.
func StateBeginTimeNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldStateBeginTime)))
	})
}

// DeadlineEQ applies the EQ predicate on the "deadline" field.
func DeadlineEQ(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDeadline), v))
	})
}

// DeadlineNEQ applies the NEQ predicate on the "deadline" field.
func DeadlineNEQ(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldDeadline), v))
	})
}

// DeadlineIn applies the In predicate on the "deadline" field.
func DeadlineIn(vs ...time.Time) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldDeadline), v...))
	})
}

// DeadlineNotIn applies the NotIn predicate on the "deadline" field.
func DeadlineNotIn(vs ...time.Time) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldDeadline), v...))
	})
}

// DeadlineGT applies the GT predicate on the "deadline" field.
func DeadlineGT(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldDeadline), v))
	})
}

// DeadlineGTE applies the GTE predicate on the "deadline" field.
func DeadlineGTE(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldDeadline), v))
	})
}

// DeadlineLT applies the LT predicate on the "deadline" field.
func DeadlineLT(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldDeadline), v))
	})
}

// DeadlineLTE applies the LTE predicate on the "deadline" field.
func DeadlineLTE(v time.Time) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldDeadline), v))
	})
}

// DeadlineIsNil applies the IsNil predicate on the "deadline" field.
func DeadlineIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldDeadline)))
	})
}

// DeadlineNotNil applies the NotNil predicate on the "deadline" field.
func DeadlineNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldDeadline)))
	})
}

// AttemptsEQ applies the EQ predicate on the "attempts" field.
func AttemptsEQ(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldAttempts), v))
	})
}

// AttemptsNEQ applies the NEQ predicate on the "attempts" field.
func AttemptsNEQ(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldAttempts), v))
	})
}

// AttemptsIn applies the In predicate on the "attempts" field.
func AttemptsIn(vs ...int) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldAttempts), v...))
	})
}

// AttemptsNotIn applies the NotIn predicate on the "attempts" field.
func AttemptsNotIn(vs ...int) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldAttempts), v...))
	})
}

// AttemptsGT applies the GT predicate on the "attempts" field.
func AttemptsGT(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldAttempts), v))
	})
}

// AttemptsGTE applies the GTE predicate on the "attempts" field.
func AttemptsGTE(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldAttempts), v))
	})
}

// AttemptsLT applies the LT predicate on the "attempts" field.
func AttemptsLT(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldAttempts), v))
	})
}

// AttemptsLTE applies the LTE predicate on the "attempts" field.
func AttemptsLTE(v int) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldAttempts), v))
	})
}

// AttemptsIsNil applies the IsNil predicate on the "attempts" field.
func AttemptsIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldAttempts)))
	})
}

// AttemptsNotNil applies the NotNil predicate on the "attempts" field.
func AttemptsNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldAttempts)))
	})
}

// CallerDataEQ applies the EQ predicate on the "caller_data" field.
func CallerDataEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCallerData), v))
	})
}

// CallerDataNEQ applies the NEQ predicate on the "caller_data" field.
func CallerDataNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldCallerData), v))
	})
}

// CallerDataIn applies the In predicate on the "caller_data" field.
func CallerDataIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldCallerData), v...))
	})
}

// CallerDataNotIn applies the NotIn predicate on the "caller_data" field.
func CallerDataNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldCallerData), v...))
	})
}

// CallerDataGT applies the GT predicate on the "caller_data" field.
func CallerDataGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldCallerData), v))
	})
}

// CallerDataGTE applies the GTE predicate on the "caller_data" field.
func CallerDataGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldCallerData), v))
	})
}

// CallerDataLT applies the LT predicate on the "caller_data" field.
func CallerDataLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldCallerData), v))
	})
}

// CallerDataLTE applies the LTE predicate on the "caller_data" field.
func CallerDataLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldCallerData), v))
	})
}

// CallerDataContains applies the Contains predicate on the "caller_data" field.
func CallerDataContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldCallerData), v))
	})
}

// CallerDataHasPrefix applies the HasPrefix predicate on the "caller_data" field.
func CallerDataHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldCallerData), v))
	})
}

// CallerDataHasSuffix applies the HasSuffix predicate on the "caller_data" field.
func CallerDataHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldCallerData), v))
	})
}

// CallerDataIsNil applies the IsNil predicate on the "caller_data" field.
func CallerDataIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldCallerData)))
	})
}

// CallerDataNotNil applies the NotNil predicate on the "caller_data" field.
func CallerDataNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldCallerData)))
	})
}

// CallerDataEqualFold applies the EqualFold predicate on the "caller_data" field.
func CallerDataEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldCallerData), v))
	})
}

// CallerDataContainsFold applies the ContainsFold predicate on the "caller_data" field.
func CallerDataContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldCallerData), v))
	})
}

// InstanceContextEQ applies the EQ predicate on the "instanceContext" field.
func InstanceContextEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextNEQ applies the NEQ predicate on the "instanceContext" field.
func InstanceContextNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextIn applies the In predicate on the "instanceContext" field.
func InstanceContextIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldInstanceContext), v...))
	})
}

// InstanceContextNotIn applies the NotIn predicate on the "instanceContext" field.
func InstanceContextNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldInstanceContext), v...))
	})
}

// InstanceContextGT applies the GT predicate on the "instanceContext" field.
func InstanceContextGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextGTE applies the GTE predicate on the "instanceContext" field.
func InstanceContextGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextLT applies the LT predicate on the "instanceContext" field.
func InstanceContextLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextLTE applies the LTE predicate on the "instanceContext" field.
func InstanceContextLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextContains applies the Contains predicate on the "instanceContext" field.
func InstanceContextContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextHasPrefix applies the HasPrefix predicate on the "instanceContext" field.
func InstanceContextHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextHasSuffix applies the HasSuffix predicate on the "instanceContext" field.
func InstanceContextHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextIsNil applies the IsNil predicate on the "instanceContext" field.
func InstanceContextIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldInstanceContext)))
	})
}

// InstanceContextNotNil applies the NotNil predicate on the "instanceContext" field.
func InstanceContextNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldInstanceContext)))
	})
}

// InstanceContextEqualFold applies the EqualFold predicate on the "instanceContext" field.
func InstanceContextEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldInstanceContext), v))
	})
}

// InstanceContextContainsFold applies the ContainsFold predicate on the "instanceContext" field.
func InstanceContextContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldInstanceContext), v))
	})
}

// StateContextEQ applies the EQ predicate on the "stateContext" field.
func StateContextEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStateContext), v))
	})
}

// StateContextNEQ applies the NEQ predicate on the "stateContext" field.
func StateContextNEQ(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldStateContext), v))
	})
}

// StateContextIn applies the In predicate on the "stateContext" field.
func StateContextIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldStateContext), v...))
	})
}

// StateContextNotIn applies the NotIn predicate on the "stateContext" field.
func StateContextNotIn(vs ...string) predicate.InstanceRuntime {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldStateContext), v...))
	})
}

// StateContextGT applies the GT predicate on the "stateContext" field.
func StateContextGT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldStateContext), v))
	})
}

// StateContextGTE applies the GTE predicate on the "stateContext" field.
func StateContextGTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldStateContext), v))
	})
}

// StateContextLT applies the LT predicate on the "stateContext" field.
func StateContextLT(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldStateContext), v))
	})
}

// StateContextLTE applies the LTE predicate on the "stateContext" field.
func StateContextLTE(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldStateContext), v))
	})
}

// StateContextContains applies the Contains predicate on the "stateContext" field.
func StateContextContains(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldStateContext), v))
	})
}

// StateContextHasPrefix applies the HasPrefix predicate on the "stateContext" field.
func StateContextHasPrefix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldStateContext), v))
	})
}

// StateContextHasSuffix applies the HasSuffix predicate on the "stateContext" field.
func StateContextHasSuffix(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldStateContext), v))
	})
}

// StateContextIsNil applies the IsNil predicate on the "stateContext" field.
func StateContextIsNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldStateContext)))
	})
}

// StateContextNotNil applies the NotNil predicate on the "stateContext" field.
func StateContextNotNil() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldStateContext)))
	})
}

// StateContextEqualFold applies the EqualFold predicate on the "stateContext" field.
func StateContextEqualFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldStateContext), v))
	})
}

// StateContextContainsFold applies the ContainsFold predicate on the "stateContext" field.
func StateContextContainsFold(v string) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldStateContext), v))
	})
}

// HasInstance applies the HasEdge predicate on the "instance" edge.
func HasInstance() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(InstanceTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2O, true, InstanceTable, InstanceColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasInstanceWith applies the HasEdge predicate on the "instance" edge with a given conditions (other predicates).
func HasInstanceWith(preds ...predicate.Instance) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(InstanceInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.O2O, true, InstanceTable, InstanceColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasCaller applies the HasEdge predicate on the "caller" edge.
func HasCaller() predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(CallerTable, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, CallerTable, CallerColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasCallerWith applies the HasEdge predicate on the "caller" edge with a given conditions (other predicates).
func HasCallerWith(preds ...predicate.Instance) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(CallerInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, CallerTable, CallerColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.InstanceRuntime) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.InstanceRuntime) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.InstanceRuntime) predicate.InstanceRuntime {
	return predicate.InstanceRuntime(func(s *sql.Selector) {
		p(s.Not())
	})
}
