// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/vorteil/direktiv/pkg/flow/ent/logmsg"
	"github.com/vorteil/direktiv/pkg/flow/ent/predicate"
)

// LogMsgDelete is the builder for deleting a LogMsg entity.
type LogMsgDelete struct {
	config
	hooks    []Hook
	mutation *LogMsgMutation
}

// Where appends a list predicates to the LogMsgDelete builder.
func (lmd *LogMsgDelete) Where(ps ...predicate.LogMsg) *LogMsgDelete {
	lmd.mutation.Where(ps...)
	return lmd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (lmd *LogMsgDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(lmd.hooks) == 0 {
		affected, err = lmd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*LogMsgMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			lmd.mutation = mutation
			affected, err = lmd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(lmd.hooks) - 1; i >= 0; i-- {
			if lmd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = lmd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, lmd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (lmd *LogMsgDelete) ExecX(ctx context.Context) int {
	n, err := lmd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (lmd *LogMsgDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: logmsg.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: logmsg.FieldID,
			},
		},
	}
	if ps := lmd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, lmd.driver, _spec)
}

// LogMsgDeleteOne is the builder for deleting a single LogMsg entity.
type LogMsgDeleteOne struct {
	lmd *LogMsgDelete
}

// Exec executes the deletion query.
func (lmdo *LogMsgDeleteOne) Exec(ctx context.Context) error {
	n, err := lmdo.lmd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{logmsg.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (lmdo *LogMsgDeleteOne) ExecX(ctx context.Context) {
	lmdo.lmd.ExecX(ctx)
}
